// Generated by CoffeeScript 2.3.2
(function() {
  var Generator, Promise, colors, isArray, isFunction;

  colors = require("colors/safe");

  Promise = require("bluebird");

  ({isArray, isFunction} = require("./utils"));

  Generator = class Generator {
    constructor(logger) {
      this.register = this.register.bind(this);
      this.generate = this.generate.bind(this);
      this.logger = logger;
      this._ = [];
    }

    register(name, fn) {
      if (!isFunction(fn)) {
        throw new TypeError("fn must be a Function!");
        return;
      }
      return this._.push({
        "name": name,
        "fn": fn
      });
    }

    async generate(site) {
      var fn, i, len, name, ref, res, results;
      results = [];
      ref = this._;
      for (i = 0, len = ref.length; i < len; i++) {
        ({name, fn} = ref[i]);
        this.logger.debug(`Hikaru is generating \`${colors.blue(name)}\`...`);
        res = (await fn(site));
        if (res == null) {
          continue;
        }
        if (!isArray(res)) {
          results.push(res);
        } else {
          results = results.concat(res);
        }
      }
      return results;
    }

  };

  module.exports = Generator;

}).call(this);
