// Generated by CoffeeScript 2.3.2
(function() {
  var aliases, escapeHTML, highlight, highlightAuto, hljs, loadLangAliases;

  hljs = require("highlight.js");

  aliases = null;

  escapeHTML = function(str) {
    return str.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/"/g, "&#039;");
  };

  loadLangAliases = function() {
    var alias, j, k, lAliases, lang, len, len1, ref;
    aliases = {};
    ref = hljs.listLanguages();
    for (j = 0, len = ref.length; j < len; j++) {
      lang = ref[j];
      aliases[lang] = lang;
      lAliases = require(`highlight.js/lib/languages/${lang}`)(hljs)["aliases"];
      if (lAliases != null) {
        for (k = 0, len1 = lAliases.length; k < len1; k++) {
          alias = lAliases[k];
          aliases[alias] = lang;
        }
      }
    }
    return aliases;
  };

  highlightAuto = function(str) {
    var alias, data, j, lang, len;
    for (lang = j = 0, len = aliases.length; j < len; lang = ++j) {
      alias = aliases[lang];
      if (hljs.getLanguage(lang) == null) {
        hljs.registerLanguage(lang, require(`highlight.js/lib/languages/${lang}`));
      }
    }
    data = hljs.highlightAuto(str);
    if (data["relevance"] > 0 && (data["language"] != null)) {
      return data;
    }
    return {
      "value": escapeHTML(str)
    };
  };

  highlight = function(str, options = {}) {
    var data, gutters, i, j, lines, ref, results;
    if (aliases == null) {
      aliases = loadLangAliases();
    }
    if (options["hljs"]) {
      hljs.configure({
        "classPrefix": "hljs-"
      });
    }
    // Guess when no lang was given,
    if (options["lang"] == null) {
      data = highlightAuto(str);
    // Skip auto guess when user sets lang to plain,
    // plain is not in the alias list, so judge it first.
    } else if (options["lang"] === "plain") {
      data = {
        "value": escapeHTML(str)
      };
    // Guess when lang is given but not in highlightjs' alias list, too.
    } else if (aliases[options["lang"]] == null) {
      data = highlightAuto(str);
    } else {
      // We have correct lang alias, tell highlightjs to handle it.
      // If given language does not match string content,
      // highlightjs will set language to undefined.
      data = hljs.highlight(aliases[options["lang"]], str);
    }
    // Language in <figure>'s class is highlight's detected result, not user input.
    // To get user input, marked set it to parent <code>'s class.
    results = ["<figure class=\"highlight hljs"];
    if (data["language"] != null) {
      results.push(` ${data["language"].toLowerCase()}">`);
    } else {
      results.push("\">");
    }
    if (options["gutter"]) {
      gutters = ["<pre class=\"gutter\">"];
      lines = data["value"].split("\n").length;
      for (i = j = 0, ref = lines; (0 <= ref ? j < ref : j > ref); i = 0 <= ref ? ++j : --j) {
        gutters.push(`<span class="line">${i + 1}</span>\n`);
      }
      gutters.push("</pre>");
      results = results.concat(gutters);
    }
    results.push("<pre class=\"code\"><code>");
    results.push(data["value"]);
    results.push("</code></pre></figure>");
    return results.join("");
  };

  module.exports = highlight;

}).call(this);
