// Generated by CoffeeScript 2.3.2
(function() {
  var Category, File, Processor, Promise, Site, Tag, colors, isFunction;

  colors = require("colors/safe");

  Promise = require("bluebird");

  ({Site, File, Category, Tag} = require("./types"));

  ({isFunction} = require("./utils"));

  Processor = class Processor {
    constructor(logger) {
      this.register = this.register.bind(this);
      this.process = this.process.bind(this);
      this.logger = logger;
      this._ = [];
    }

    register(name, fn) {
      if (!isFunction(fn)) {
        throw new TypeError("fn must be a Function!");
        return;
      }
      return this._.push({
        "name": name,
        "fn": fn
      });
    }

    async process(site) {
      var fn, i, len, name, ref;
      ref = this._;
      for (i = 0, len = ref.length; i < len; i++) {
        ({name, fn} = ref[i]);
        this.logger.debug(`Hikaru is processing \`${colors.blue(name)}\`...`);
        site = (await fn(site));
      }
      return site;
    }

  };

  module.exports = Processor;

}).call(this);
