// Generated by CoffeeScript 2.3.2
(function() {
  var File, Promise, Renderer, colors, isFunction, path,
    indexOf = [].indexOf;

  path = require("path");

  colors = require("colors/safe");

  Promise = require("bluebird");

  ({File} = require("./types"));

  ({isFunction} = require("./utils"));

  Renderer = class Renderer {
    constructor(logger, skipRenderList) {
      this.register = this.register.bind(this);
      this.render = this.render.bind(this);
      this.logger = logger;
      this._ = {};
      this.skipRenderList = skipRenderList || [];
    }

    register(srcExt, docExt, fn) {
      if (!isFunction(fn)) {
        throw new TypeError("fn must be a Function!");
        return;
      }
      if (!(srcExt in this._)) {
        this._[srcExt] = [];
      }
      return this._[srcExt].push({
        "srcExt": srcExt,
        "docExt": docExt,
        "fn": fn
      });
    }

    render(input) {
      var basename, dirname, docExt, handler, i, len, output, ref, ref1, results, srcExt;
      srcExt = path.extname(input["srcPath"]);
      results = [];
      if (srcExt in this._ && (ref = input["srcPath"], indexOf.call(this.skipRenderList, ref) < 0)) {
        ref1 = this._[srcExt];
        for (i = 0, len = ref1.length; i < len; i++) {
          handler = ref1[i];
          output = new File(input);
          docExt = handler["docExt"];
          if (docExt != null) {
            dirname = path.dirname(output["srcPath"]);
            basename = path.basename(output["srcPath"], srcExt);
            output["docPath"] = path.join(dirname, `${basename}${docExt}`);
            this.logger.debug(`Hikaru is rendering \`${colors.cyan(output["srcPath"])}\` to \`${colors.cyan(output["docPath"])}\`...`);
          } else {
            output["docPath"] = output["srcPath"];
            this.logger.debug(`Hikaru is rendering \`${colors.cyan(output["srcPath"])}\`...`);
          }
          results.push(handler["fn"](output));
        }
      } else {
        // Or if file has no registered renderer...
        output = new File(input);
        output["docPath"] = output["srcPath"];
        this.logger.debug(`Hikaru is rendering \`${colors.cyan(output["srcPath"])}\`...`);
        output["content"] = output["raw"];
        results.push(output);
      }
      return results;
    }

  };

  module.exports = Renderer;

}).call(this);
